unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, DBCtrls, ExtCtrls, StdCtrls, JPEG;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    Database1: TDatabase;
    Table1: TTable;
    DataSource1: TDataSource;
    Table1Codigo: TFloatField;
    Table1Nome: TStringField;
    Table1Imagem: TBlobField;
    Label1: TLabel;
    DBText1: TDBText;
    Label2: TLabel;
    Label3: TLabel;
    DBText2: TDBText;
    Image1: TImage;
    BtImagem: TButton;
    Query1: TQuery;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
    procedure BtImagemClick(Sender: TObject);
    procedure Table1BeforePost(DataSet: TDataSet);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  private
    { Private declarations }
  public
    { Public declarations }
    Procedure MostraImagem;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  DataBase1.Close;
  DataBase1.Params.Values[ 'PATH' ] := ExtractFilePath( Application.ExeName );
  DataBase1.open;
  Table1.Open;
end;

procedure TForm1.DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
begin
  If Button = nbInsert Then
    BtImagem.Enabled := True
  Else
    BtImagem.Enabled := False;
end;

procedure TForm1.BtImagemClick(Sender: TObject);
begin
  If ( OpenDialog1.Execute ) Then
    Begin
      Table1Nome.AsString := OpenDialog1.FileName;
      Image1.Picture.LoadFromFile( OpenDialog1.FileName );
    End;
end;

procedure TForm1.Table1BeforePost(DataSet: TDataSet);
Var
  nNum: Integer;
  stImagemStream: TFileStream;
  stBlobStream: TBlobStream;
begin
  Query1.Open;
  Query1.First;
  If Query1.EOF Then
    nNum := 0
  Else
    nNum := Query1.Fields[0].AsInteger;
  Query1.Close;
  Inc( nNum );
  Table1Codigo.AsInteger := nNum;
  //
  stImagemStream := TFileStream.Create(
                       OpenDialog1.FileName,
                       fmOpenRead OR fmShareDenyWrite );
  stBlobStream := TBlobStream.Create( Table1Imagem, bmWrite );
  Try
    stBlobStream.CopyFrom( stImagemStream, stImagemStream.Size );
  Finally
    stImagemStream.Free;
    stBlobStream.Free;
  End;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  If DataSource1.DataSet.State In [ dsBrowse ] Then
    MostraImagem;
end;

Procedure TForm1.MostraImagem;
Var
  stBlobStream: TBlobStream;
  jpgImagem: TJPEGImage;
Begin
  stBlobStream := TBlobStream.Create( Table1Imagem, bmRead );
  jpgImagem    := TJPEGImage.Create;
  Try
    jpgImagem.LoadFromStream( stBlobStream );
    Image1.Picture.Assign( jpgImagem );
  Finally
    stBlobStream.Free;
    jpgImagem.Free;
  End;
End;

end.
